let stage
let rijirotheme
let newlevels
let fft
let amp
let vol




//the code to preload my songs into my p5 sketch
function preload(){
  soundFormats("mp3");
  rijirotheme = loadSound("rijirotheme.mp3");
  newlevels = loadSound("newlevels.mp3");
}

//setting up canvas, setting up toggle sound to stop my sketch when mouseclicked, also adding in the ftt and amp
function setup() {
  let cnv = createCanvas(1750, 900);
  cnv.mouseClicked(toggleSound);
  stage = "songOne"
  rijirotheme.setVolume(1.5);
  ftt = new p5.FFT();
  amp = new p5.Amplitude();
  

}


function draw() {
  //the set up of my stage conditionals so I can have 2 states within my sketch, seen as "song one" and "song two"
  
  if(stage == "songOne"){
    songOne()
    
  }
  if(stage == "songTwo"){
    songTwo()
  }
}

//keypresses, adding interactivity so user can switch between states and stop/start sketch by pressing the 1,2,3 keys and mouseclicked
function keyPressed(){
 if(keyIsPressed){
   if(key == "1"){
     stage = "songOne"
     rijirotheme.play();
   }
 }                         
 if(keyIsPressed){                     //as seen, if key 2 is pressed, the sketch will take you to stage 2 where songTwo new levels plays
   if(key == "2"){
     stage = "songTwo"
     newlevels.play();
   }
 }
 if(keyPressed){                     //when song 2 starts and stage 2 is loaded, Rijirotheme(songOne) stops playing, therefore they dont overlap each other
  if(key == "2"){
    rijirotheme.stop();
  }
 }

 if(keyPressed){
  if(key == "1"){
    newlevels.stop();
  }
 }

 if(keyIsPressed){                  //added in an extra key (3) so that the user can stop the audio
  if(key == "3"){
    rijirotheme.stop();
  }
 }

 if(keyIsPressed){
  if(key == "3"){
    newlevels.stop();
  }
 }
}

function toggleSound(){                 //added togglesound so that the user can stop/start the audio with the click of a mouse
  if (rijirotheme.isPlaying()) {
    rijirotheme.stop();
  }
  if (newlevels.isPlaying()) {
    newlevels.stop();
  }
}










//Visualisation, this is where i have the code for my 2 states


function songOne(){  //songOne sketch
  background(random(1000*vol));  //background *vol to make the flashes on the sketch match play with the audio
  stroke(255);
  {text('Press keys 1 or 2 to play/change state, press 3 or click canvas to stop', width/2.9, 20); //text applied to the top of the screen to give user instructions on how to interact with the sketch
  }
  

  translate(width / 2, height / 2);  //sets the groups of points in the centre of the canvas
  vol = amp.getLevel()               //retreiving amp levels
 

  let noOfPoints = 1000; //points in circle
  
  for(let i = vol*88; i < noOfPoints; i++*amp) {   
  rotate(TWO_PI / noOfPoints*vol*360); //points interacting with the amp level causing the points to flash

  strokeWeight(11);
  stroke(random(255), random(255), random(255)); //random colours set
  point(0, height/4);
}

 for(i=0;i<10;i+=25){     //ellipse made reaching to outer sections of the dots made above, several ellipse react to the volume from the centre point
  strokeWeight(8);
  stroke(122, 220, 155);
  ellipse(i,50,vol*50);
  ellipse(i,100,vol*200);
  ellipse(i,200,vol*350);
  


  for(var x = -300; x <= width; x+=88*amp){      //ellipse made again, altered to make thin random rbg lines that move around the main dots codeed above
    for(var y = -300; y <= height; y+=100){
    stroke(random(100), random(100), (100));
    strokeWeight(random(0), (10));
    fill(random(255), random(255), random(255));
    ellipse(x, 50, 5, 1005);}
    fill(random(200), random(200), random(200));  //random rgb values added to the ellipses'
    ellipse(250, 50, 10, 1005);}
    fill(255);
 }
}






function songTwo(){ //songTwosketch
  background(random(1000*vol)); //background *vol to make the flashes on the sketch match play with the audio
  stroke(255);
  {{text('Press keys 1 or 2 to play/change state, press 3 or click canvas to stop', width/2.9, 20);
  }}
  
 
  translate(width / 2, height / 2);    //sets the groups of points in the centre of the canvas
  vol = amp.getLevel()                 //retreiving amp levels
 

  let noOfPoints = 300;
  
  for(let i = vol*10; i < noOfPoints; i++*amp) {    //ellipse made reaching to outer section of the dots made above, several ellipse react to the volume from the centre point
  rotate(TWO_PI / noOfPoints*vol*1000);       

  strokeWeight(11);  
  stroke(255);      //random rgb values of the stroke set
  point(0, height/4);
}

 for(i=0;i<10;i+=25){           //ellipse made reaching to outer section of the dots made above, several ellipse react to the volume from the centre point
  strokeWeight(8);
  stroke(122, 220, 155);
  ellipse(i,50,vol*50);
  ellipse(i,100,vol*200);
  ellipse(i,200,vol*600);


  for(var x = -300; x <= width; x+=50*amp){           //ellipse made again, this time designed to make ellipse patterns around the circle reacting to the amp levels
    for(var y = -300; y <= height; y+=100){
    stroke(random(100), random(100), (100));
    strokeWeight(7);2
    fill(random(40), random(255), random(150));
    ellipse(x, y, 100, 600);}
    fill(0,20,255);}
  } 
}

